<% @LANGUAGE=VBScript %>
<%  
    If Not IsObject(Application("Thread1")) Then
        Set Application("Thread1") = Server.CreateObject("newObjects.utilctls.COMScriptThread.free")
    End If
    Set thread = Application("Thread1")
    
    Message = ""
    
    ' Initialize the max number for user convenience
    If Request("MaxNum") = "" Then 
        MaxNum = 30000
    Else
        MaxNum = CLng(Request("MaxNum"))
    End If
    
    If Request("Start").Count > 0 Then
        If Not thread.Busy Then
            ' Start the new thread operation
            thread.Stop     ' Call this to ensure the previous script is unloaded
                            ' Even if this is the first time Stop will just do nothing
                            ' if there is no script loaded in the thread.
                            
            ' Configure the thread's parameters
            thread.Value("MaxNum") = CLng(Request("MaxNum"))
            thread.Value("CurNum") = CLng(0)
            thread.Value("Found") = CLng(0)
            thread.Value("Results") = ""
                            
            Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
            Set file = sf.OpenFile(Server.MapPath(Request("Script")),&H40)
            
            ' Start the thread.
            ' We do not use "wait" parameter because in this sample we perform the
            ' work in the main body of the thread script and there is no poit to
            ' run it parallely if we would wati it to finish.
            If Not thread.Start("VBScript",file.ReadText(-2)) Then
                ' An error has occured. In this kind of usage it could be only a critical error
                ' caused by the OS state for example. In many cases you can leave the result
                ' unchecked.
                Message = "Error starting the thread: " & thread.LastError
            Else
                Message = "Thread has been started. See/re-check the state to follow the progress and check for run-time errors"
            End If
        Else
            Message = "Thread is still busy. Try to start it again later. Check the state to see its current progress."
        End If
    ElseIf Request("Stop").Count > 0 Then
        ' Set the stop indicator
        thread.Value("Stop") = True
        ' Wait the thread to see it and stop gracefully
        If thread.Wait(5000) Then
            Message = "The thread stopped in response to the stop indicator"
        Else
            Message = "The thread did not stop after 5 seconds. Perhaps the script in it is not designed to recognize the Stop indicator."
        End If
        thread.Value("Stop") = False
    ElseIf Request("ForceStop").Count > 0 Then
        ' This is forced stop
        ' We set the stop indicator
        thread.Value("Stop") = True
        thread.Timeout = 6000
        ' But we will not wait for gracefull completion
        ' Instead we set the thread internal timeout to 6 seconds and we call Stop
        thread.Stop
        ' This will forcibly kill the thread if it is not able to stop gracefully for the
        ' period specified in thread.Timeout
        Message = "The has been stopped forcibly."
        ' After forced stop it is recommended to re-create the thread object.
        ' IT IS STRONGLY RECOMMENDED TO NOT USE FORCED THREAD STOP IN PRODUCTION ENVIRONMENTS
        ' THIS TECHNIQUE SHOULD BE USED ONLY DURING THE DEVELOPMENT PROCESS TO GET RID OF
        ' LOCK UPS CAUSED BY MISTAKES IN YOUR CODE.
        Set Application("Thread1") = Nothing
        Set Application("Thread1") = Server.CreateObject("newObjects.utilctls.COMScriptThread.free")
    End If
    
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="/styles.css">
<title>ALP Sample</title>
</head>

<body>

<form method="POST" action="<%= Request.ServerVariables("SCRIPT_NAME") %>">
  <p>Maximum number: <input type="text" name="MaxNum" size="20" VALUE="<%= MaxNum %>"> 
  <input type="submit" value="Start thread" name="Start"><BR>
  Use script:
  <SELECT NAME="Script">
    <OPTION VALUE="thread1.vbs">thread1.vbs (correct script)</OPTION>
    <OPTION VALUE="thread2.vbs">thread2.vbs (script with a syntax error)</OPTION>
    <OPTION VALUE="thread3.vbs">thread3.vbs (script which produces run-time error)</OPTION>
    <OPTION VALUE="thread4.vbs">thread4.vbs (correct but ignoring the stop indicator)</OPTION>
  </SELECT>
  </p>
  <P><FONT COLOR="#F04000"><%= Message %></FONT></P>
  <p><A HREF="<%= Request.ServerVariables("SCRIPT_NAME") %>">Check state</A></p>
  <% If thread.Busy Then %>
  <P>
        <input type="submit" value="Stop the thread" name="Stop">
        <input type="submit" value="Forcibly stop the thread" name="ForceStop"><BR>
        <I>If your machine is to fast increase the max number to allow the script run longer and test the thread stopping. A value of 100000 should 
        cause a few minutes execution on the most machines.
        </I>
  </P>
  <% End If %>
  <% If thread.Busy Then %>
    <TABLE WIDTH="100%">
        <TR>
            <TD>Thread state</TD>
            <TD><B>Running</B></TD>
        </TR>
        <TR>
            <TD>Current number</TD>
            <TD><B><%= thread.Value("CurNum") %></B></TD>
        </TR>
        <TR>
            <TD>Prime numbers found</TD>
            <TD><B><%= thread.Value("Found") %></B></TD>
        </TR>
        <TR>
            <TD VALIGN="TOP">Current results</TD>
            <TD><%= thread.Value("Results") %></TD>
        </TR>
    </TABLE>
  <% Else %>
    <% If IsEmpty(thread.Value("MaxNum")) Then %>
        <TABLE WIDTH="100%">
            <TR>
                <TD>Thread state</TD>
                <TD><B>Has not been started yet.</B></TD>
            </TR>
        </TABLE>
    <% Else %>  
        <% If thread.Success Then %>
            <TABLE WIDTH="100%">
                <TR>
                    <TD>Thread state</TD>
                    <TD><B>Finished Successfuly</B></TD>
                </TR>
                <TR>
                    <TD>Max number checked</TD>
                    <TD><B><%= thread.Value("CurNum") %></B></TD>
                </TR>
                <TR>
                    <TD>Prime numbers found</TD>
                    <TD><B><%= thread.Value("Found") %></B></TD>
                </TR>
                <TR>
                    <TD VALIGN="TOP">Results</TD>
                    <TD><%= thread.Value("Results") %></TD>
                </TR>
            </TABLE>
        <% Else %>
            <TABLE WIDTH="100%">
                <TR>
                    <TD>Thread state</TD>
                    <TD><B>Error occured</B></TD>
                </TR>
                <TR>
                    <TD>Error</TD>
                    <TD><B><%= thread.LastError %></B></TD>
                </TR>
                <TR>
                    <TD>Max number checked</TD>
                    <TD><B><%= thread.Value("CurNum") %></B></TD>
                </TR>
                <TR>
                    <TD>Prime numbers found</TD>
                    <TD><B><%= thread.Value("Found") %></B></TD>
                </TR>
                <TR>
                    <TD VALIGN="TOP">Results</TD>
                    <TD><%= thread.Value("Results") %></TD>
                </TR>
            </TABLE>
        <% End If %>
    <% End If %>
  <% End If %>
  
</form>

</body>

</html>
